# Headless CMS

## Contents of this file

- [Introduction](#introduction)
- [Requirements](#requirements)
- [Installation](#installation)
- [Configuration](#configuration)
- [Maintainers](#maintainers)

## Introduction

The goal of this module is to provide missing functionality to Drupal
that is needed or beneficial for headless / decoupled CMS setups.

Functionality is split into submodules, which can be enabled individually.
So you can enable only the functionality you need for your headless setup.

### Functionality

The following functionality is provided:

|Submodule|Description|
|---|---|
|[Preview](modules/headless_cms_preview)|Provides integration for node preview mode and revisions to view in an external frontend application.|
|[Preview - NATS](modules/headless_cms_preview_nats)|Allows publish preview updates to a NATS server.|
|[Notify](modules/headless_cms_notify)|Allows sending notifications of various events to external applications via transports.|
|[Notify - Webhook](modules/headless_cms_notify_webhook)|Provides a notify transport to notify via webhook requests.|
|[Notify - NATS](modules/headless_cms_notify_nats)|Provides a notify transport to notify via a NATS server.|

See the README.md files in the submodules for more information.

## Requirements

The core module requires Drupal 10.3 or 11 and the following contrib modules:

- [Consumers](https://www.drupal.org/project/consumers)

## Installation

Install as you would normally install a contributed Drupal module. For further
information, see
[Installing Drupal Modules](https://www.drupal.org/docs/extending-drupal/installing-drupal-modules).

## Configuration

Configuration is done on the modules settings page at
`/admin/config/headless-cms`.

## Maintainers

Current maintainers:

- Christoph Niedermoser ([@nimoatwoodway](https://www.drupal.org/u/nimoatwoodway))
- Christian Foidl ([@chfoidl](https://www.drupal.org/u/chfoidl))
