<?php

declare(strict_types=1);

namespace Drupal\headless_cms_notify\Entity;

use Drupal\Core\Config\Entity\ConfigEntityInterface;
use Drupal\headless_cms_notify\HeadlessNotifyTransportPluginInterface;

/**
 * Provides an interface for HeadlessNotifyTransport config entities.
 */
interface HeadlessNotifyTransportInterface extends ConfigEntityInterface {

  /**
   * Gets the transport plugin.
   */
  public function getTransportPlugin(): ?HeadlessNotifyTransportPluginInterface;

  /**
   * Gets the transport plugin ID.
   */
  public function getTransportPluginId(): ?string;

  /**
   * Sets the transport plugin.
   */
  public function setTransportPlugin(HeadlessNotifyTransportPluginInterface $transport);

  /**
   * Validates the transport configuration entity.
   */
  public function validate();

}
