<?php

declare(strict_types=1);

namespace Drupal\headless_cms_notify;

use Drupal\Component\Plugin\PluginInspectionInterface;
use Drupal\headless_cms_notify\NotifyMessage\HeadlessNotifyMessageInterface;

/**
 * Provides an interface for HeadlessNotifyTransport plugins.
 */
interface HeadlessNotifyTransportPluginInterface extends PluginInspectionInterface {

  /**
   * Send a message.
   */
  public function send(HeadlessNotifyMessageInterface $message): void;

  /**
   * Get the label.
   */
  public function getLabel(): string;

}
