<?php

declare(strict_types=1);

namespace Drupal\headless_cms_notify;

use Drupal\Core\Cache\CacheBackendInterface;
use Drupal\Core\Extension\ModuleHandlerInterface;
use Drupal\Core\Plugin\DefaultPluginManager;

/**
 * HeadlessNotifyTransport plugin manager.
 */
class HeadlessNotifyTransportPluginManager extends DefaultPluginManager {

  public function __construct(
    \Traversable $namespaces,
    CacheBackendInterface $cache_backend,
    ModuleHandlerInterface $module_handler,
  ) {
    $type = 'headless_cms_notify_transport';

    parent::__construct(
      'Plugin/HeadlessNotifyTransport',
      $namespaces,
      $module_handler,
      'Drupal\headless_cms_notify\HeadlessNotifyTransportPluginInterface',
      'Drupal\headless_cms_notify\Attribute\HeadlessNotifyTransport',
    );

    $this->alterInfo($type . '_info');
    $this->setCacheBackend($cache_backend, $type, ['headless_cms_notify_transport_plugins']);
  }

}
