<?php

declare(strict_types=1);

namespace Drupal\headless_cms_notify;

use Drupal\headless_cms_notify\Entity\HeadlessNotifyTransportInterface;
use Drupal\headless_cms_notify\NotifyMessage\HeadlessNotifyMessageInterface;

/**
 * Provides an interface for HeadlessNotifyTransport services.
 */
interface HeadlessNotifyTransportServiceInterface {

  /**
   * Load all available HeadlessNotifyTransport plugins.
   */
  public function loadTransportPlugins(): array;

  /**
   * Send a message via a HeadlessNotifyTransport plugin.
   */
  public function send(HeadlessNotifyMessageInterface $message, HeadlessNotifyTransportInterface $transport): void;

  /**
   * Validate a HeadlessNotifyTransport plugin.
   */
  public function validate(HeadlessNotifyTransportInterface $transport): void;

}
