<?php

declare(strict_types=1);

namespace Drupal\headless_cms_preview\Event;

use Drupal\Core\Entity\EntityInterface;
use Drupal\Core\Session\AccountInterface;
use Symfony\Contracts\EventDispatcher\Event;

/**
 * Event for when a headless preview is updated.
 */
class HeadlessPreviewUpdatedEvent extends Event {

  public const EVENT_NAME = 'headless_cms_preview.preview_updated';

  public function __construct(
    public readonly EntityInterface $entity,
    public readonly AccountInterface $account,
  ) {}

}
