# Headless CMS - Preview NATS

## Contents of this file

- [Introduction](#introduction)
- [Requirements](#requirements)
- [Installation](#installation)
- [Configuration](#configuration)

## Introduction

This submodule extends the Headless CMS Preview functionality by adding NATS
integration for real-time preview updates. When content editors save a preview,
the module automatically publishes these updates to a configured NATS server,
enabling immediate preview updates in decoupled frontend applications.

### Key Features

- Publishes preview updates to NATS
- Configurable NATS client
- Configurable NATS subject prefix for published messages

### For what is this for?

If you want to implement live-reload functionality for node previews in 
a decoupled frontend application, update messages can be listened on via
NATS to reload the preview data in real-time.

## Requirements

This module requires:

- Drupal 10.3 or 11
- Headless CMS Preview (parent module)
- NATS Server (running and accessible from Drupal)
- NATS module properly configured

## Requirements

The core module requires Drupal 10.3 or 11 and the following contrib modules:

- [Consumers](https://www.drupal.org/project/consumers)
- [NATS](https://www.drupal.org/project/nats)

## Installation

Install as you would normally install a contributed Drupal module. For further
information, see
[Installing Drupal Modules](https://www.drupal.org/docs/extending-drupal/installing-drupal-modules).

## Configuration

Configuration is done on the Headless CMS Preview settings page at
`/admin/config/headless-cms/preview` where you can configure:

- Whether to enable NATS integration
- NATS client to use
- Subject prefix for published messages
